<template>
  <div class="wrapper">
    <div
      class="section page-header header-filter"
      :style="headerStyle"
      style="height: 1000px"
    >
      <div class="container">
        <div class="md-layout">
          <form
            ref="form"
            novalidate
            class="md-layout"
            @submit.prevent="onSubmit"
          >
            <md-card
              class="md-layout-item md-size-80 md-small-size-100 mx-auto"
              style="padding-bottom: 20px;"
            >
              <md-card-header>
                <div class="md-title">
                  <h2
                    style="letter-spacing: 2px;color: green;margin-top:30px; text-align: center"
                  >
                    <strong>Prodi</strong>
                  </h2>
                </div>
              </md-card-header>

              <md-card-content>
                <div class="md-layout md-gutter">
                  <div class="md-layout-item md-small-size-100">
                    <md-field :class="getValidationClass('nama_prodi')">
                      <label for="nama_prodi">Nama Prodi...</label>
                      <md-input
                        name="nama_prodi"
                        id="nama_prodi"
                        v-model="prodiData.nama_prodi"
                        md-dense
                        :disabled="sending"
                      >
                      </md-input>
                      <span
                        class="md-error"
                        v-if="!$v.prodiData.nama_prodi.required"
                        >Nama Prodi is required</span
                      >
                    </md-field>
                  </div>

                  <div class="md-layout-item md-small-size-100">
                    <md-field :class="getValidationClass('singkatan_prodi')">
                      <label for="singkatan_prodi">Singkatan Prodi...</label>
                      <md-input
                        name="singkatan_prodi"
                        id="singkatan_prodi"
                        v-model="prodiData.singkatan_prodi"
                        md-dense
                        :disabled="sending"
                      >
                      </md-input>
                      <span
                        class="md-error"
                        v-if="!$v.prodiData.singkatan_prodi.required"
                        >Singkatan Prodi is required</span
                      >
                    </md-field>
                  </div>
                </div>

                <br />

                <div class="md-layout md-gutter">
                  <div class="md-layout-item md-small-size-100">
                    <md-field :class="getValidationClass('fakultas_id')">
                      <label for="fakultas_id">Kategori Thesis...</label>
                      <md-select
                        name="fakultas_id"
                        id="fakultas_id"
                        v-model="prodiData.fakultas_id"
                        md-dense
                        :disabled="sending"
                      >
                        <md-option
                          v-for="(fakultas, key) in fakultasList"
                          :key="key"
                          :value="fakultas.id"
                          style="left: 10px"
                        >
                          {{ fakultas.nama_fakultas }}
                        </md-option>
                      </md-select>
                      <span
                        class="md-error"
                        v-if="!$v.prodiData.fakultas_id.required"
                        >Fakultas is required</span
                      >
                    </md-field>
                  </div>

                  <div class="md-layout-item md-small-size-100">
                    <md-field :class="getValidationClass('logo')">
                      <label for="logo">Logo Prodi...</label>
                      <md-file
                        ref="logo"
                        name="logo"
                        id="logo"
                        v-model="prodiData.logo"
                        @md-change="onFileUpload($event)"
                        placeholder="Upload Foto Kaprodi"
                        :disabled="sending"
                      />
                      <span class="md-error" v-if="!$v.prodiData.logo.required"
                        >Logo Prodi is required</span
                      >
                    </md-field>
                  </div>
                </div>
              </md-card-content>

              <md-card-actions style="padding-top: 50px">
                <md-button
                  type="submit"
                  class="md-success md-lg md-round"
                  :disabled="sending"
                  style="height: 50px; width: 100%;"
                  >Submit</md-button
                >
              </md-card-actions>

              <md-progress-bar md-mode="indeterminate" v-if="sending" />
            </md-card>

            <md-snackbar :md-active.sync="userSaved"
              >The user was saved with success!</md-snackbar
            >
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { validationMixin } from "vuelidate";
import { required, minLength, maxLength } from "vuelidate/lib/validators";
import Quill from "quill";

export default {
  name: "FormValidation",
  mixins: [validationMixin],
  data: () => ({
    editorOption: {},
    form: {
      nama_prodi: null,
      fakultas_id: null,
      singkatan_prodi: null,
      logo: null
    },
    userSaved: false,
    sending: false
  }),
  validations: {
    prodiData: {
      nama_prodi: {
        required
      },
      fakultas_id: {
        required
      },
      singkatan_prodi: {
        required
      },
      logo: {
        required
      }
    }
  },
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    }
  },
  computed: {
    ...mapState("prodi", ["prodiData"]),
    ...mapState("fakultas", ["fakultasList"]),
    editor() {
      return this.$refs.myQuillEditor.quill;
    },
    headerStyle() {
      return {
        backgroundImage: `url(${this.header})`
      };
    }
  },
  methods: {
    ...mapActions("prodi", ["getProdi", "updateProdi"]),
    ...mapActions("fakultas", ["getFakultasList"]),
    async onFetchData() {
      await this.getProdi({ id: this.$route.params.id });
      await this.getFakultasList();
    },
    onFileUpload(event) {
      this.logo = event[0];
      this.prodiData.logo = event[0];
    },
    async onSubmit() {
      this.$v.$touch();
      this.sending = true;
      if (!this.$v.invalid) {
        try {
          let formData = new FormData();
          for (const property in this.prodiData) {
            // console.log(property, this.prodiData[property]);
            formData.append(property, this.prodiData[property]);
          }
          // let image = this.$refs.image.files[0];
          formData.append("logo", this.logo);
          await this.updateProdi({
            id: this.$route.params.id,
            payload: formData
          });

          // console.log(formData);
          this.prodiData = {};
          this.$router.push({ name: "prodi-management" });
        } catch (error) {
          this.sending = false;
          throw Error(error);
        }
      }
    },
    // onEditorBlur(quill) {
    //   console.log("editor blur!", quill);
    // },
    // onEditorFocus(quill) {
    //   console.log("editor focus!", quill);
    // },
    // onEditorReady(quill) {
    //   console.log("editor ready!", quill);
    // },
    onEditorChange({ quill, html, text }) {
      // console.log("editor change!", quill, html, text);
      this.content = html;
    },
    getValidationClass(fieldName) {
      const field = this.$v.prodiData[fieldName];

      if (field) {
        return {
          "md-invalid": field.$invalid && field.$dirty
        };
      }
    },
    clearForm() {
      this.$v.$reset();
      this.form.nama_prodi = null;
      this.form.fakultas_id = null;
      this.form.singkatan_prodi = null;
      this.form.logo = null;
    },
    saveUser() {
      this.sending = true;
      window.setTimeout(() => {
        this.userSaved = true;
        this.sending = false;
        this.clearForm();
      }, 1500);
    },
    validateUser() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.saveUser();
      }
    }
  },
  async mounted() {
    await this.onFetchData();
    // console.log("this is current quill instance object", this.editor);
  }
};
</script>

<style lang="scss" scoped>
.md-progress-bar {
  margin: 24px;
}
</style>
